<?php

define('HASH_SALT',     'alfdLSKJDGSo4twd8932405r9D{AFS9p');

function getTitleUrl($path, $subdomain)
{
	$url = 'https://'.$subdomain . '.' . $_SERVER['SERVER_NAME'] . '/events/'.$path.'/?action=title&h=';
	$dnes = date('y-m-d');
	$plain_hash = "$path|action:title|$dnes|".HASH_SALT;
	return $url . hash('sha256', $plain_hash);
}

function getEvPhotoUrl($path, $subdomain, $pass, $photo)
{
	$url = 'https://'.$subdomain . '.' . $_SERVER['SERVER_NAME'] . '/events/'.$path.'/?action=preview&name='.$photo.'&quality=medium&h=';
	$dnes = date('y-m-d');
	if (strlen($pass) > 0)
		$plain_hash = "$path|$pass|action:preview|name:$photo|quality:medium|$dnes|".HASH_SALT;
	else
		$plain_hash = "$path|action:preview|name:$photo|quality:medium|$dnes|".HASH_SALT;
	return $url . hash('sha256', $plain_hash);
}

function getEvOriginalUrl($path, $subdomain, $pass, $photo)
{
	$url = 'https://'.$subdomain . '.' . $_SERVER['SERVER_NAME'] . '/events/'.$path.'/?action=original&name='.$photo.'&h=';
	$dnes = date('y-m-d');
	if (strlen($pass) > 0)
		$plain_hash = "$path|$pass|action:original|name:$photo|$dnes|".HASH_SALT;
	else
		$plain_hash = "$path|action:original|name:$photo|$dnes|".HASH_SALT;
	return $url . hash('sha256', $plain_hash);
}

function getEventSize($path)
{
	global $curr;
	$cmd = 'du -sh '.EVENT_FILES.$curr.$path;
	exec($cmd, $output, $retval);
	if ($retval != 0 || !is_array($output) || count($output) < 1)
		return "0KB";
	$parts = explode("\t", $output[0]);
	if (!is_array($parts) || count($parts) < 1)
		return "0KB";
	return $parts[0].'B';
}

function getEventPhotos($path)
{
	global $curr;
	$cmd = 'ls -1 '.EVENT_FILES.$curr.$path.'/lpreviews/*.jpg | wc -l';
	exec($cmd, $output, $retval);
	if ($retval != 0 || !is_array($output) || count($output) < 1)
		return "0";
	return $output[0];
}

function getEventList($db, $hidden)
{
	$rv = array();
	$result = $db->query('SELECT * FROM events ORDER BY hidden ASC, created DESC');
	while ($row = $result->fetchArray(SQLITE3_ASSOC))
	{
		if ($row['hidden'] >= 1)
		{
			if (!$hidden)
				continue;
		}
		else
		{
			if ($hidden)
				continue;
		}
		$rv[] = $row;
	}
	return $rv;
}

function getEvent($db, $id)
{
	$rv = array();
	$result = $db->query('SELECT * FROM events WHERE event_id = '.$id);
	if ($row = $result->fetchArray(SQLITE3_ASSOC))
		return $row;
	return FALSE;
}

function getEventPhotoList($path)
{
	global $curr;
	$sl = scandir(EVENT_FILES.$curr.$path.'/lpreviews/');
	$rv = array();
	foreach ($sl as $e)
	{
		$r = explode('.', $e, 2);
		if (count($r) == 2 && strcasecmp($r[1], 'jpg') != 0)
			continue;
		$rv[] = $r[0];
	}
	return $rv;
}

function getEventPhotoDT($path, $photo)
{
	global $curr;
        $cmd = 'stat -c %Y '.EVENT_FILES.$curr.$path.'/originals/'.$photo.'.jpg';
        exec($cmd, $output, $retval);
        if ($retval != 0 || !is_array($output) || count($output) < 1)
                return "";

        return date('Y-m-d H:i', $output[0]);
}

function rmEventPhoto($path, $photo)
{
	global $curr;
	unlink (EVENT_FILES.$curr.$path.'/originals/'.$photo.'.jpg');
	unlink (EVENT_FILES.$curr.$path.'/hpreviews/'.$photo.'.jpg');
	unlink (EVENT_FILES.$curr.$path.'/mpreviews/'.$photo.'.jpg');
	unlink (EVENT_FILES.$curr.$path.'/lpreviews/'.$photo.'.jpg');
}

function hideEvent($db, $id)
{
	return $db->exec("UPDATE events SET hidden = 1 WHERE event_id = '$id'");
}

function showEvent($db, $id)
{
	return $db->exec("UPDATE events SET hidden = 0 WHERE event_id = '$id'");
}

function getEventPassword($path)
{
	global $curr;
        $cmd = 'head -n 2 '.BASE_DIR.$curr.INDEX_FILES.$path.'/index.php | grep password';
        exec($cmd, $output, $retval);
        if ($retval != 0 || !is_array($output) || count($output) < 1)
                return "";
        $parts = explode("'", $output[0]);
        if (!is_array($parts) || count($parts) < 1)
                return "";
        return $parts[1];
}

function setEventPassword($db, $id, $path, $newpass)
{
	global $curr;

	$indexFile = BASE_DIR.$curr.INDEX_FILES.$path.'/index.php';	
	if (file_exists($indexFile))
		unlink($indexFile);
	$indexContent = "<?php\n";
	if (strlen($newpass) > 0)
		$indexContent .= '$password = \''.$newpass."';\n";
	$indexContent .= '$cdir = \''.$curr."';\n";
	$indexContent .= "\n";
	$indexContent .= file_get_contents('../event-index.tmpl');
	file_put_contents($indexFile, $indexContent);

	if (strlen($newpass) > 0)
	{
		$db->exec("UPDATE events SET public = 0 WHERE event_id = '$id'");
	}
	else
	{
		$db->exec("UPDATE events SET public = 1 WHERE event_id = '$id'");
	}
}

function setEventName($db, $id, $newname)
{
	if (strlen($newname) <= 0)
		return;

	$escname = $db->escapeString($newname);
	$db->exec("UPDATE events SET name = '$escname' WHERE event_id = '$id'");
}

function setEventDesc($db, $id, $newdesc)
{
	if (strlen($newdesc) <= 0)
		return;

	$escdesc = $db->escapeString($newdesc);
	$db->exec("UPDATE events SET desc = '$escdesc' WHERE event_id = '$id'");
}

function setEventTitle($db, $id, $path, $titlephoto)
{
	global $curr;

	$srcFile = EVENT_FILES.$curr.$path.'/hpreviews/'.$titlephoto.'.jpg';
	$titleFile = EVENT_FILES.$curr.$path.'/title/title.jpg';	
	$cmd = 'convert -resize "310^>" "'.$srcFile.'" -gravity center -crop 310x310+0+0 -strip -quality 95% "'.$titleFile.'"';
	exec($cmd, $output, $retval);
	if ($retval != 0)
		return;

	$thash = substr(sha1_file($titleFile), 0, 8);
	$db->exec("UPDATE events SET title = '$thash' WHERE event_id = '$id'");
}

