<?php
require_once('event_functions.php');

function echoHead()
{
	echo "<html>\n";
	echo "<head>\n";
	echo "	<meta http-equiv=\"content-type\" content=\"text/html; charset=utf-8\" />\n";
	echo "	<title>Smybox live administration</title>\n";
	echo "	<link rel=\"stylesheet\" type=\"text/css\" href=\"style.css\" />\n";
	echo "</head>\n";
	echo "<body>\n";
}

function echoFoot()
{
	echo "</body>\n";
	echo "</html>\n";
}

function echoEventList($db)
{
	foreach($_POST as $pkey => $pval)
	{
		if (strncmp($pkey, "hide", 4) == 0)
		{
			$id = substr($pkey, 4);
			if (is_numeric($id))
				hideEvent($db, 0+$id);
			continue;
		}
		if (strncmp($pkey, "show", 4) == 0)
		{
			$id = substr($pkey, 4);
			if (is_numeric($id))
				showEvent($db, 0+$id);
			continue;
		}
	}

	echo "<h1>\n<span style=\"font-size:24px;\">Smybox live: events administration</span></h1><br>\n";
	$list = getEventList($db, isset($_GET['hidden']));

	$offset = 0;
	if (isset($_GET['offset']) && is_numeric($_GET['offset']))
		$offset = -1+$_GET['offset'];
	if ($offset < 0)
		$offset = 0;
	if ($offset > (((count($list)-1) / EVENT_LISTING)))
		$offset = ((count($list)-1) / EVENT_LISTING);

	$gc = '';
	if (isset($_GET['hidden']))
	{
		$gc = 'class="grayEvent"';
		echo 'Number of hidden events: '.count($list)."<br>\n<a href=\"?offset=0\">Display VISIBLE events</a><br><br>\n";
	}
	else
	{
		echo 'Number of visible events: '.count($list)."<br>\n<a href=\"?hidden=1\">Display HIDDEN events</a><br><br>\n";
	}

	echo "<form action=\"\" method=\"post\">\n";
	echo "<table>\n";
	echo "<tr><th>Title</th><th>Name</th><th>Password</th><th>Date</th><th>Photos</th><th>Size</th><th>Subdomain</th><th>&nbsp;</th></tr>\n";

	$alt = 0;

	for ($i = $offset * EVENT_LISTING; $i < count($list) && $i < ($offset+1) * EVENT_LISTING; $i++)
	{
		$row = $list[$i];
		//foreach ($list as $row)

		if ($alt++ % 2)
			echo '<tr class="alt">';
		else
			echo '<tr>';

		echo "<td $gc><a href=\"?event=".$row['event_id']."\"><img src=\"".getTitleUrl($row['path'], $row['subdomain'])."\" height=\"155\" width=\"155\"></a></td>";
		echo "<td $gc>".$row['name']."</td><td>".getEventPassword($row['path'])."</td><td $gc>".$row['created']."</td>";
		echo "<td $gc>".getEventPhotos($row['path'])."</td><td $gc>".getEventSize($row['path'])."</td>";
		echo "<td $gc>".$row['subdomain']."</td>";

		if (isset($_GET['hidden']))
			echo "<td><input type=\"submit\" name=\"show".$row['event_id']."\" value=\"Show\"></td>";
		else
			echo "<td><input type=\"submit\" name=\"hide".$row['event_id']."\" value=\"Hide\"></td>";

		echo "</tr>\n";
	}
	echo "</table>\n";
	echo "</form>\n";

	if (count($list) > EVENT_LISTING)
	{
		echo "<form action=\"\" method=\"get\">\n";
		echo "Pages: \n";
		if (isset($_GET['hidden']))
			echo "<input type=\"hidden\" name=\"hidden\" value=\"1\">";

		for ($i = 0; $i < (count($list)/EVENT_LISTING); $i++)
		{
			if ($i == $offset)
				echo ' <span style="font-size: 140%;">'.($i+1).'</span> ';
			else
				echo "<input type=\"submit\" name=\"offset\" value=\"".($i+1)."\">";
		}
		echo "</form>";
	}
}

function echoEvent($db, $id)
{
	$event = getEvent($db, $id);
	if (!$event)
		return;

	$mfile='../events/'.$event['path'].'/mails-sended.txt';
	$tsmfile='../events/'.$event['path'].'/mails-to-send.txt';
	if (isset($_GET['mails']))
	{
		if (file_exists($mfile))
		{
			$lines=explode("\n", file_get_contents($mfile));
			$mails=array();
			foreach ($lines as $l)
			{
				$list=explode(" ", $l);
				if (count($list) < 2)
					continue;
				$mails[$list[0]] = $list[1];
			}
			ksort($mails);
		
			echo "<pre>\n";
			foreach ($mails as $mail => $c)
				echo $mail."\n";
			echo "</pre>\n";
		}
		else
			echo "<p>No mails sended</p>\n";
	}
	else if (isset($_GET['tsmails']))
	{
                if (file_exists($tsmfile))
                {
                        $lines=explode("\n", file_get_contents($tsmfile));
                        $mails=array();
                        foreach ($lines as $l)
                        {
                                $list=explode(" ", $l);
                                if (count($list) < 2)
                                        continue;
                                $mails[$list[0]] = $list[1];
                        }
                        ksort($mails);

                        echo "<pre>\n";
                        foreach ($mails as $mail => $c)
                                echo $mail."\n";
                        echo "</pre>\n";
                }
                else
                        echo "<p>No mails to send</p>\n";
	}
	else 
	{
		$photos = getEventPhotoList($event['path']);
		$pcount = count($photos);
		$offset = 0;
		$pass   = getEventPassword($event['path']);

		foreach($_GET as $gkey => $gval)
		{
			if (strncmp($gkey, "delEvPhoto", 10) == 0)
			{
				$photo = substr($gkey, 10);
				rmEventPhoto($event['path'], $photo);
			}
			if (strncmp($gkey, "setEvTitle", 10) == 0)
			{
				$photo = substr($gkey, 10);
				setEventTitle($db, $id, $event['path'], $photo);
			}
		}

		if (isset($_GET['offset']) && is_numeric($_GET['offset']))
			$offset = -1+$_GET['offset'];
		if ($offset < 0)
			$offset = 0;
		if ($offset > ((($pcount-1) / EVENT_LISTING)))
			$offset = (($pcount-1) / EVENT_LISTING);

		if (isset($_GET['newname']) && $_GET['newname'] != $event['name'])
		{
			$event['name'] = $_GET['newname'];
			setEventName($db, $id, $event['name']);
		}

		if (isset($_GET['newpass']) && $_GET['newpass'] != $pass)
		{
			$pass = $_GET['newpass'];
			setEventPassword($db, $id, $event['path'], $pass);
		}

		if (isset($_GET['newdesc']) && $_GET['newdesc'] != $event['name'])
		{
			$event['desc'] = $_GET['newdesc'];
			setEventDesc($db, $id, $event['desc']);
		}

		echo "<form><input type=\"submit\" name=\"back\" value=\"Back to event list\"></form><br>\n";
		echo '<h2>Event details</h2>';
		echo "<form action=\"\" method=\"get\">\n";
		echo "<input type=\"hidden\" name=\"event\" value=\"$id\">";
		if ($offset > 0)
			echo '<input type="hidden" name="offset" value="'.($offset+1).'">';
		echo "<table>\n";
		echo "<tr><th>&nbsp;</th><th>Value</th></tr>\n";
		echo '<tr><td>Name</td><td><input type="input" name="newname" size="35" value="'.$event['name'].'"></td></tr>';
		echo '<tr><td>Title</td><td><img src="'.getTitleUrl($event['path'], $event['subdomain']).'" height=\"155\" width=\"155\"></td></tr>';
		echo '<tr><td>Password</td><td><input type="input" name="newpass" size="35" value="'.$pass.'"></td></tr>';
		echo '<tr><td>Description</td><td><input type="input" name="newdesc" size="50" value="'.$event['desc'].'"></td></tr>';
		if (file_exists($mfile))
			echo '<tr><td>Sended mails</td><td><a href="?event='.$id.'&mails" target="_blank">list</a></td></tr>';
		if (file_exists($tsmfile))
			echo '<tr><td>Mails to send</td><td><a href="?event='.$id.'&tsmails" target="_blank">list</a></td></tr>';
		echo "</table>\n";
		echo "<input type=\"submit\" name=\"offset\" value=\"Update\"><br><br>";
		echo "</form>";


		echo "Number of photos: $pcount<br>\n";
		if ($pcount > 0)
		{
			echo "<form action=\"\" method=\"get\">\n";
			echo "<input type=\"hidden\" name=\"event\" value=\"$id\">";
			if ($offset > 0)
				echo '<input type="hidden" name="offset" value="'.($offset+1).'">';
			echo "<table>\n";
			echo "<tr><th>Photo</th><th>Created</th><th>Image</th><th>&nbsp;</th><th>&nbsp;</th></tr>\n";

			$alt = 0;
			for ($i = $offset * EVENT_LISTING; $i < $pcount && $i < ($offset+1) * EVENT_LISTING; $i++)
			{
				if ($alt++ % 2)
					echo '<tr class="alt">';
				else
					echo '<tr>';
				echo '<td>'.$photos[$i].'</td><td>'.getEventPhotoDT($event['path'], $photos[$i]).'</td>';
				echo '<td><a href="'.getEvOriginalUrl($event['path'], $event['subdomain'], $pass, $photos[$i]).'" target="_blank"><img src="'.getEvPhotoUrl($event['path'], $event['subdomain'], $pass, $photos[$i]).'" height="310" width="310"></a></td>';
				echo "<td><input type=\"submit\" name=\"delEvPhoto".$photos[$i]."\" value=\"Delete\"></td>";
				echo "<td><input type=\"submit\" name=\"setEvTitle".$photos[$i]."\" value=\"Title\"></td>";
				echo "</tr>\n";
			}

			echo "</table>\n";
			echo "</form>";
		}

		if ($pcount > EVENT_LISTING)
		{
			echo "<form action=\"\" method=\"get\">\n";
			echo "Pages: \n";
			echo "<input type=\"hidden\" name=\"event\" value=\"$id\">";

			for ($i = 0; $i < ($pcount/EVENT_LISTING); $i++)
			{
				if ($i == $offset)
					echo ' <span style="font-size: 140%;">'.($i+1).'</span> ';
				else
					echo "<input type=\"submit\" name=\"offset\" value=\"".($i+1)."\">";
			}
			echo "</form>";
		}
	}		
}

