<?php
include_once('defines.php');
include_once('database.php');
include_once('validator.php');
include_once('logging.php');

if (!verify_request(array(), $_GET))
{
  log_request(1, HASH_ERROR);
  die ('{"error":'.HASH_ERROR."}\n");
}

$reply['error'] = REQUEST_ERROR;

if (isset($_GET['action']) && $_GET['action'] == 'version')
{
  $reply['error'] = NO_ERROR;
  $reply['version'] = "1.3";
  $reply['compatible'] = "1.1";
  log_request(1, NO_ERROR);
  die (json_encode($reply));
}

if (isset($_GET['action']) && ($_GET['action'] == 'state' || $_GET['action'] == 'list' || $_GET['action'] == 'branches'))
{
  $db = new EventsDB();
  $reply['error'] = INTERNAL_ERROR;
  if(!$db)
  {
    log_request(1, INTERNAL_ERROR);
    die (json_encode($reply));
  }

  $b = -1;
  if (isset($_GET['branch']) && is_numeric($_GET['branch']))
    $b = 0+$_GET['branch'];

  if ($_GET['action'] == 'state')
  {
    $l = $db->getList($b);
    if (!($l === NULL))
    {
      $reply['error'] = NO_ERROR;
      $reply['branch'] = $b;
      if (count($l) == 0)
        $reply['state'] = 0;
      else
        $reply['state'] = substr(sha1(json_encode($l)), 0, 10);
    }
    else
      $reply['error'] = REQUEST_ERROR;
  }

  if ($_GET['action'] == 'list')
  {
    $l = $db->getList($b);
    if (!($l === NULL))
    {
      $reply['error'] = NO_ERROR;
      $reply['branch'] = $b;
      $reply['list'] = $l;
    }
  }

  if ($_GET['action'] == 'branches')
  {
    $br = $db->getBranches();
    if (!($br === NULL))
    {
      $reply['error'] = NO_ERROR;
      $reply['branches'] = $br;
    }
  }

  $db->close();
}


log_request(1, $reply['error']);
echo json_encode($reply);

