PRAGMA encoding = "UTF-8";

CREATE TABLE IF NOT EXISTS events
(event_id INTEGER PRIMARY KEY,
created INTEGER NOT NULL DEFAULT CURRENT_TIMESTAMP,
public NUMERIC NOT NULL DEFAULT 0,
lang VARCHAR(2) NOT NULL DEFAULT 'en',
fk_branch_id INTEGER NOT NULL,
path VARCHAR(16) NOT NULL,
title VARCHAR(10) NOT NULL,
subdomain VARCHAR(10) NOT NULL,
name VARCHAR(128) NOT NULL,
hidden INTEGER NOT NULL DEFAULT 0,
del_counter INTEGER NOT NULL DEFAULT 0,
desc TEXT,
locality TEXT);

CREATE INDEX events_i1 ON events (fk_branch_id ASC);
CREATE INDEX events_i2 ON events (path ASC);

CREATE TABLE IF NOT EXISTS branches
(branch_id INTEGER PRIMARY KEY,
bstatecode VARCHAR(5) NOT NULL,
bstate VARCHAR(64) NOT NULL,
bname VARCHAR(64) NOT NULL,
bweb VARCHAR(64) NOT NULL,
bcontact VARCHAR(64) NOT NULL);

CREATE TABLE IF NOT EXISTS hwkeys
(hwkey BIGINT,
desc VARCHAR(32) NOT NULL,
fk_branch_id INTEGER NOT NULL,
subdomain VARCHAR(10) NOT NULL);

INSERT INTO branches (branch_id, bstatecode, bstate, bname, bweb, bcontact) VALUES ('1', 'CZ', 'Czech Republic', 'Smilebox', 'www.smilebox.cz', 'ahoj@smilebox.cz');
INSERT INTO branches (branch_id, bstatecode, bstate, bname, bweb, bcontact) VALUES ('2', 'BR', 'Brazil', 'Magicbox', 'www.lovemagicbox.com', 'contato@lovemagicbox.com');
INSERT INTO branches (branch_id, bstatecode, bstate, bname, bweb, bcontact) VALUES ('3', 'ES', 'Spain', 'Smybox', 'www.smybox.es', 'hola@smybox.es');
INSERT INTO branches (branch_id, bstatecode, bstate, bname, bweb, bcontact) VALUES ('4', 'US-CA', 'USA - California', 'Mr.Smilebox', 'www.mrsmilebox.com', 'hello@mrsmilebox.com');
INSERT INTO branches (branch_id, bstatecode, bstate, bname, bweb, bcontact) VALUES ('5', 'RO', 'Romania', 'Smybox', 'www.smybox.ro', 'smile@smybox.ro');
INSERT INTO branches (branch_id, bstatecode, bstate, bname, bweb, bcontact) VALUES ('6', 'DE', 'Germany', 'Smybox', 'www.smybox.de', 'hallo@smybox.de');

INSERT INTO hwkeys (hwkey, desc, fk_branch_id, subdomain) VALUES (287454020, 'Popp', '1', 'cz1');
INSERT INTO hwkeys (hwkey, desc, fk_branch_id, subdomain) VALUES (1076770444, '1ka', '1', 'cz1');
INSERT INTO hwkeys (hwkey, desc, fk_branch_id, subdomain) VALUES (243448351, '2ka', '1', 'cz1');
INSERT INTO hwkeys (hwkey, desc, fk_branch_id, subdomain) VALUES (508751892, '3ka', '1', 'cz1');
INSERT INTO hwkeys (hwkey, desc, fk_branch_id, subdomain) VALUES (1064271985, '4ka', '1', 'cz1');
INSERT INTO hwkeys (hwkey, desc, fk_branch_id, subdomain) VALUES (478500465, '5ka', '3', 'es1');
INSERT INTO hwkeys (hwkey, desc, fk_branch_id, subdomain) VALUES (1807649415, '6ka', '1', 'cz1');

INSERT INTO hwkeys (hwkey, desc, fk_branch_id, subdomain) VALUES (71260933, 'LA', '4', 'cz1');
INSERT INTO hwkeys (hwkey, desc, fk_branch_id, subdomain) VALUES (339281608, 'MB', '2', 'br1');

INSERT INTO hwkeys (hwkey, desc, fk_branch_id, subdomain) VALUES (1123425580, 'DE1', '6', 'cz1');
INSERT INTO hwkeys (hwkey, desc, fk_branch_id, subdomain) VALUES (1955218996, '8ka', '1', 'cz1');
