#!/bin/bash
from='mail/replace-in-html'

if [ $# -lt 3 ] ; then
  echo "Usage: $0 <html_file> <subject> <event_path>"
  exit 1
fi

if [ ! -d "events/$3" ] ; then
  echo "Event dir events/$3 doesn't exists"
  exit 1
fi

if [ ! -e "$1" ] ; then
  echo "HTML file $1 doesn't exists"
  exit 1
fi

ph=`cat "$1" | grep '\\\$\\\$URL\\\$\\\$' | wc -l`

if [ "$ph" -lt 1 ] ; then
  echo "Warning: Missing placeholder \$\$URL\$\$ in HTML"
fi

cp "$from/mbuilder.php" events/$3/
cp "$1" "events/$3/mail.html"

ms="events/$3/make-send.sh"

echo '#!/bin/bash' > "$ms"
echo "subject=\"$2\"" >> "$ms"
echo "path=\"$3\"" >> "$ms"
tail -n+4 "$from/make-send.sh" >> "$ms"
chmod a+x "$ms"
chown -R www-data:www-data events/$3

echo DONE
