#!/bin/bash
subject="subject"
path="994d2a047b4f797e"

from="T-Mobile workplace <workplace@smybox.cz>"
smtpacc="workplace"

if [ $# -lt 2 ] ; then
  echo "Usage: $0 <mail> <attachmet1> [<attachment2>] [<attachment3>]"
  exit 1
fi

to=$1
boundary="CVXj2FWLmwYeOYU+AMT6gzdD3yikZZT"
body="mail.html"
apath="/srv/live/$path/originals"

# Build headers
{

printf '%s\n' "From: $from
To: $to
Subject: $subject
Mime-Version: 1.0
Content-Type: multipart/mixed; boundary=\"$boundary\"

--${boundary}
Content-Type: text/html; charset=\"utf-8\"

"
php mbuilder.php cz1.live.smybox.com $path $2 $body
 
# now loop over the attachments, guess the type
# and produce the corresponding part, encoded base64
for fileloc in "${@:2}"; do
  file="$apath/$fileloc.jpg"

  [ ! -f "$file" ] && echo "Warning: attachment $file not found, skipping" >&2 && continue

  mimetype=$(file -b --mime-type "$file") 
 
  printf '%s\n' "--${boundary}
Content-Type: $mimetype
Content-Transfer-Encoding: base64
Content-Disposition: attachment; filename=\"$fileloc.jpg\"
"
 
  base64 "$file"
  echo
done
 
# print last boundary with closing --
printf '%s\n' "--${boundary}--"
 
# one may also use -f here to set the envelope-from
} | msmtp -a $smtpacc $to

