#!/bin/bash

cd /var/www/live/events

for event in *
do
	if [ ! -d "${event}" ]; then
		#echo Skip $event
		continue
	fi
	if [ ! -e "$event/mails-to-send.txt" ]; then
		continue
	fi
	if [ ! -e "$event/make-send.sh" ]; then
		continue
	fi
	cd "$event"
	mv mails-to-send.txt processing-mails.txt
	cat processing-mails.txt | while read line
	do
		./make-send.sh $line
		rc=$?
		if [[ $rc != 0 ]]; then
			echo error when sending $line
			echo $line >> mails-to-send.txt
		else
			#echo OK sended $line
			echo $line >> mails-sended.txt
		fi
	done
	rm processing-mails.txt
	chown www-data:www-data *
	cd ../
done

