<?php
include_once('defines.php');
include_once('updatabase.php');
include_once('event-factory.php');

$allowed_types = array('image/jpeg', 'image/jpg', 'image/gif');
$allowed_exts = array('jpeg', 'jpg', 'JPEG', 'JPG', );

function isEventReq()
{
  return (isset($_GET['hevent']) || isset($_GET['event'])) &&
          isset($_GET['ename']) && isset($_GET['edesc']) &&
         (isset($_GET['hpass']) || isset($_GET['epass'])) &&
          isset($_GET['hwkey']) && isset($_GET['lang']);
}

function isTitleReq()
{
  return isset($_POST['epath']) && isset($_POST['title']);
}

function isImageReq()
{
  return isset($_POST['epath']) && isset($_POST['image']);
}

function isGifReq()
{
  return isset($_POST['epath']) && isset($_POST['gif']);
}

function isDeleteReq()
{
  return (isset($_GET['hevent']) || isset($_GET['event'])) && isset($_GET['delete']);
}

function isEmailReq()
{
  return isset($_GET['hevent']) && isset($_GET['email']);
}

function getUploadedFileHashes()
{
	$retVal = array();
	if (!isset($_FILES['imgs']) || !isset($_FILES['imgs']['name']))
		return $retVal;
	$file_count = count($_FILES['imgs']['name']);
	for ($i=0; $i<$file_count; $i++)
		$retVal[] = sha1_file($_FILES['imgs']['tmp_name'][$i]);
	//var_dump($_FILES['imgs']);
	return $retVal;
}

function makeEventReq($curr)
{
  $reply['error'] = REQUEST_ERROR;
  $event = '';
  if (isset($_GET['hevent']))
    $event = hex2bin($_GET['hevent']);
  else if (isset($_GET['event']))
    $event = $_GET['event']; //TODO: Delete tis out of date
  else
    return $reply;

  $pass = '';
  if (isset($_GET['hpass']))
    $pass = hex2bin($_GET['hpass']);
  else if (isset($_GET['epass']))
    $pass = $_GET['epass'];
  else
    return $reply;

  $reply['error'] = EVENT_FACTORY_ERROR;

  $eFactory = new EventFatory($curr, $event, $_GET['ename'], $_GET['edesc'], $pass, $_GET['hwkey'], $_GET['lang']);
  if(!$eFactory || !($eFactory->isValid()))
    return $reply;

  $db = new UploadDB();
  if(!$db)
  {
    $reply['error'] = INTERNAL_ERROR;
    return $reply;
  }

  list($subDomain, $branch) = $db->getSubdomain($eFactory->getHwKey());
  if ($subDomain === NULL || strlen($subDomain) < 1)
  {
    $reply['error'] = UNAUTHORIZED_ERROR;
    return $reply;
  }

  if (!($eFactory->eventDirExists()))
  {
    if (!($eFactory->prepareEvent()))
    {
      $reply['error'] = EVENT_CREATE_ERROR;
      return $reply;
    }
  }
  else
  {
    $oldPass = $eFactory->mineEventPass();
    if ($oldPass != $pass)
      $eFactory->makeEventIndex();
  }

  if (!($eFactory->updateDb($db,$subDomain,$branch)))
  {
    $reply['error'] = EVENT_IORU_ERROR;
    return $reply;
  }

  $reply['error'] = NO_ERROR;
  $reply['subdomain'] = $subDomain;
  $reply['event'] = $eFactory->getPath();
  $reply['title'] = $eFactory->getTitleHash();

  $db->close();
  return $reply;
}

function makeTitletReq($curr)
{
  if (!isset($_FILES['imgs']))
    return FILE_ERROR;

  if (count($_FILES['imgs']['name']) < 1)
    return FILE_COUNT_ERROR;

  if ($_FILES['imgs']['error'][0])
    return FILE_UP_ERROR;

  if ($_FILES['imgs']['size'][0] >= IMG_SIZE_LIMIT)
    return FILE_SIZE_ERROR;

  global $allowed_types;
  if (!in_array($_FILES['imgs']['type'][0], $allowed_types))
    return FILE_TYPE_ERROR;

  global $allowed_exts;
  $file_name_parts = explode('.', $_FILES['imgs']['name'][0]);

  $extension = end($file_name_parts);
  if (!in_array($extension, $allowed_exts))
    return FILE_EXT_ERROR;

  $eFactory = new EventFatory($curr, $_POST['epath']);
  if(!$eFactory || !($eFactory->isValid()))
    return EVENT_FACTORY_ERROR;

  $db = new UploadDB();
  if(!$db)
    return INTERNAL_ERROR;

  if (!($eFactory->updateTitle($db, $_FILES['imgs']['tmp_name'][0], $_POST['title'])))
    return FILE_MOVE_ERROR;

  return NO_ERROR;
}

function makeImageReq($curr)
{
  if (!isset($_FILES['imgs']))
    return FILE_ERROR;

  if (count($_FILES['imgs']['name']) < 1)
    return FILE_COUNT_ERROR;

  if ($_FILES['imgs']['error'][0])
    return FILE_UP_ERROR;

  if ($_FILES['imgs']['size'][0] >= IMG_SIZE_LIMIT)
    return FILE_SIZE_ERROR;

  global $allowed_types;
  if (!in_array($_FILES['imgs']['type'][0], $allowed_types))
    return FILE_TYPE_ERROR;

  $eFactory = new EventFatory($curr, $_POST['epath']);
  if(!$eFactory || !($eFactory->isValid()))
    return EVENT_FACTORY_ERROR;

  if (!($eFactory->insertOriginal($_FILES['imgs']['tmp_name'][0], $_POST['image'])))
    return FILE_MOVE_ERROR;

  if (!($eFactory->makePreviews($_POST['image'])))
    return FILE_RESIZE_ERROR;

  return NO_ERROR;
}

function makeGifReq($curr)
{
  if (!isset($_FILES['imgs']))
    return FILE_ERROR;

  if (count($_FILES['imgs']['name']) < 1)
    return FILE_COUNT_ERROR;

  if ($_FILES['imgs']['error'][0])
    return FILE_UP_ERROR;

  if ($_FILES['imgs']['size'][0] >= IMG_SIZE_LIMIT)
    return FILE_SIZE_ERROR;

  global $allowed_types;
  if (!in_array($_FILES['imgs']['type'][0], $allowed_types))
    return FILE_TYPE_ERROR;

  $eFactory = new EventFatory($curr, $_POST['epath']);
  if(!$eFactory || !($eFactory->isValid()))
    return EVENT_FACTORY_ERROR;

  if (!($eFactory->insertGif($_FILES['imgs']['tmp_name'][0], $_POST['gif'])))
    return FILE_MOVE_ERROR;

  if (!($eFactory->uploadPreview($_POST['gif'])))
    return FILE_UPLOAD_ERROR;

  return NO_ERROR;
}

function makeDeleteReq($curr)
{
  $event = '';
  if (isset($_GET['hevent']))
    $event = hex2bin($_GET['hevent']);
  else if (isset($_GET['event']))
    $event = $_GET['event']; //TODO: Delete tis out of date
  else
    return REQUEST_ERROR;

  $eFactory = new EventFatory($curr, $event);
  if(!$eFactory || !($eFactory->isValid()))
    return EVENT_FACTORY_ERROR;

  if (!($eFactory->deleteFoto($_GET['delete'])))
    return FILE_ERROR;

  return NO_ERROR;
}

function makeEmailReq($curr)
{
  $req = explode('/emails:/', hex2bin($_GET['email']));
  if (count($req) != 2)
    return REQUEST_ERROR;

  $event = hex2bin($_GET['hevent']);
  $eFactory = new EventFatory($curr, $event);
  if(!$eFactory || !($eFactory->isValid()))
    return EVENT_FACTORY_ERROR;

  if (!($eFactory->saveMailReq(explode('/', $req[1]), explode('/', $req[0]))))
    return FILE_ERROR;

  return NO_ERROR;
}

